﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Spreadsheet;
using DocumentFormat.OpenXml;

namespace MultiTasking
{
    public partial class Form3 : Form
    {
        //Fixed Global Variables
        int prev_score = 0, total_score = 0;
        int version;
        int trial_ind = -1;
        int[] trial = new int[30];
        string username;
        List<MaskedTextBox> mTextboxList = new List<MaskedTextBox>();
        List<MaskedTextBox> sTextboxList = new List<MaskedTextBox>();
        bool cursor = true;
        bool delete_numb = false, delete_letter = false, finish = false;
        Stopwatch stopWatch = new Stopwatch();

        //Refreshable Global Variables
        Random rnd = new Random();
        int pause = 9, pause_Index;
        int score = 200, points = 0, correct_letters = 0, correct_digits = 0;
        double[] text_time = new double[10];
        double[] sub_time = new double[10];
        string textDisplay="", subDisplay="", textResponse="", subResponse="";
        int t = 0, s = 0, s_ind = 0;
        int score_ind = 0;

        public void restart()
        {
          //Hide Content
            panel2.Visible = false;
            panel1.Visible = false;
            panel4.Visible = false;
            panel3.Visible = false;
            submit.Visible = false;
          //Check End
            trial_ind++;
            if (trial_ind == 30)
            {
                //End Trial
                finish = true;
                tabControl1.SelectedIndex = 3;
                finish = false;
            }
            else
            {
                version = trial[trial_ind];
                finish = true;
                tabControl1.SelectedIndex = 1;
                finish = false;
                //Refresh Values
                rnd = new Random();
                points = 0; correct_letters = 0; correct_digits = 0;
                text_time = new double[10];
                sub_time = new double[10];
                textDisplay = ""; subDisplay = ""; textResponse = ""; subResponse = "";
                t = 0; s = 0; s_ind = 0; score_ind = 0;
                delete_numb = false; delete_letter = false; finish = false;
                //Refresh Content
                trialLabel.Text = (trial_ind + 1).ToString() + "/" + "30";
                textBox2.Text = "";
                textBox4.Text = "";
                for (int i = 0; i < 10; i++)
                {
                    sTextboxList[i].ForeColor = SystemColors.WindowText;
                    sTextboxList[i + 10].ForeColor = SystemColors.WindowText;
                    mTextboxList[i].Text = "";
                }
                //delete_numb = false;
                button1.Enabled = false;
                submit.Enabled = false;
                /*for (int i = 0; i < 10; i++)
                {
                    mTextboxList[i].Text = "";
                }*/
                pointsLabel.Text = "200";
                label8.Text = "";
                label9.Text = "";
                label10.Text = "";
                label11.Text = "";
                label12.Text = "";
                label13.Text = "";
                //Generate Content
                Subtract(rnd);
                TextEntry(rnd);
                //Unhide Content
                panel2.Visible = true;
                panel1.Visible = true;
                panel4.Visible = true;
                panel3.Visible = true;
                tableLayoutPanel2.Enabled = true;
                tableLayoutPanel3.Enabled = true;
                groupBox1.Enabled = true;
                mTextboxList[s].Select();
                stopWatch.Start();
                score = 200;
                submit.Visible = true;
                Cursor.Position = new Point(this.Width/2, this.Height/2);
            }
        }

        public Form3()
        {
            InitializeComponent();
            textBox5.Select();
            //Disable Controls
            /*ProcessModule objCurrentModule = Process.GetCurrentProcess().MainModule;
            objKeyboardProcess = new LowLevelKeyboardProc(captureKey);
            ptrHook = SetWindowsHookEx(13, objKeyboardProcess, GetModuleHandle(objCurrentModule.ModuleName), 0);
            */
            SubControl(); //disable right click
            //Generate trial sequence
            Sequence(rnd);
            //Refresh at every trial
            //restart();
        }
        
        //Transistions
        private void t1()
        {
            switch (version)
            {
                case 1:
                case 3:
                    stringText.Text = textDisplay[t].ToString();
                    panel1.Visible = false;
                    panel2.Visible = true;
                    mTextboxList[s].Select();
                    break;
                case 2:
                case 4:
                    stringText.Text = "";
                    panel1.Visible = false;
                    panel2.Visible = true;
                    mTextboxList[s].Select();
                    break;
                case 5:
                    stringText.Text = "";
                    panel2.Visible = false;
                    break;
                case 6:
                    stringText.Text = textDisplay[t].ToString();
                    panel2.Visible = false;
                    break;
            }
        }
        private void t2()
        {
            switch (version)
            {
                case 1:
                case 2:
                case 3:
                case 4:
                    panel2.Visible = false;
                    panel1.Visible = true;
                    break;
                case 5:
                case 6:
                    panel1.Visible = false;
                    break;
            }
        }

        //Event Triggers
        //Entry and edit
        private void letter_Click(object sender, EventArgs e)
        {            
            if (t < 10)
            {
                stopWatch.Stop();
                TimeSpan ts = stopWatch.Elapsed;
                stopWatch.Reset();
                stopWatch.Start();
                text_time[t] += ts.TotalMilliseconds;
                Console.Write(t + " ");
                Console.WriteLine(text_time[t]);
                Button button = (Button)sender;
                textResponse += button.Text;
                textBox2.Text = textResponse;
                //textBox1.Enabled = false;
                //tableLayoutPanel1.Enabled = false;
                t++;
                delete_numb = false;
                delete_letter = true;
                button1.Enabled = true;
                //Termination
                if (t == 10)
                {
                    //delete_letter = false;
                    groupBox1.Enabled = false;
                    if (s == 10)
                    {
                        submit.Enabled = true;
                    }
                    else
                    {
                        panel2.Visible = true;
                        mTextboxList[s].Select();
                    }
                }
                else
                {
                    //Transistion
                    t1();
                }
            }
        }
        private void del_letter_Click(object sender, EventArgs e)
        {
            /*if (t > 0)
            {
                t--;
            }
            if (!String.IsNullOrEmpty(textResponse))
            {
                textResponse = textResponse.Substring(0, textResponse.Length - 1);
            }
            textBox2.Text = textResponse;
            //textBox1.Enabled = true;
            //tableLayoutPanel1.Enabled = true;
            delete_letter = false;
            button1.Enabled = false;*/
        }
        private void numb_TextChanged(object sender, EventArgs e)
        {
            MaskedTextBox tb = (MaskedTextBox)sender;
            if (s < 10 && tb.Text.Length != 0)
            {
                stopWatch.Stop();
                TimeSpan ts = stopWatch.Elapsed;
                stopWatch.Reset();
                stopWatch.Start();
                sub_time[s] += ts.TotalMilliseconds;
                Console.Write(s + " ");
                Console.WriteLine(sub_time[s]);
                subResponse += tb.Text;
                textBox4.Text = subResponse;
                if (version==3 || version==4 || version==6)
                {
                sTextboxList[s].ForeColor = System.Drawing.Color.White;
                sTextboxList[s + 10].ForeColor = System.Drawing.Color.White;
                }
                s++;
                if (s != 10)
                {
                    mTextboxList[s].Select();
                }
                delete_letter = false;
                delete_numb = true;
                //Termination
                if (s == 10)
                {
                    //delete_numb = false;
                    tableLayoutPanel2.Enabled = false;
                    tableLayoutPanel3.Enabled = false;
                    if (t == 10)
                    {
                        submit.Enabled = true;
                    }
                    else
                    {
                        panel1.Visible = true;
                        groupBox1.Enabled = true;
                    }
                }
                else
                {
                    t2();
                }
            }
        }
        private void del_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.R && tabControl1.SelectedIndex != 0)
            {
                //System.Threading.Thread.Sleep(10000);
                //pause_Index = tabControl1.SelectedIndex;
                stopWatch.Stop();
                timer1.Stop();
                /*finish = true;
                tabControl1.SelectedIndex = 4;
                finish = false;
                pauseLabel.Text = "10";
                timer2.Start();*/
                MessageBox.Show("Click OK to unpause", "Paused");
                timer1.Start();
                stopWatch.Start();
            }
            if (delete_numb && e.KeyCode == Keys.Delete && tabControl1.SelectedIndex == 1)
            {
                Console.WriteLine("Delete");
                panel1.Visible = false;
                panel2.Visible = true;
                tableLayoutPanel2.Enabled = true;
                tableLayoutPanel3.Enabled = true;
                if (s > 0)
                {
                    s--;
                }
                mTextboxList[s].Text = "";
                mTextboxList[s].Select();
                sTextboxList[s].ForeColor = System.Drawing.Color.Black;
                sTextboxList[s + 10].ForeColor = System.Drawing.Color.Black;
                if (!String.IsNullOrEmpty(subResponse))
                {
                    subResponse = subResponse.Substring(0, subResponse.Length - 1);
                }
                textBox4.Text = subResponse;
                delete_numb = false;
            }
            if (delete_letter && e.KeyCode == Keys.Delete && tabControl1.SelectedIndex == 1)
            {
                panel2.Visible = false;
                panel1.Visible = true;
                groupBox1.Enabled = true;
                if (t > 0)
                {
                    t--;
                }
                if (version == 1 || version == 3 || version == 6)
                {
                    stringText.Text = textDisplay[t].ToString();
                }
                if (!String.IsNullOrEmpty(textResponse))
                {
                    textResponse = textResponse.Substring(0, textResponse.Length - 1);
                }
                textBox2.Text = textResponse;
                //textBox1.Enabled = true;
                //tableLayoutPanel1.Enabled = true;
                delete_letter = false;
                button1.Enabled = false;
            }
        }
        //Disable Controls
        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)
        {
            if (!finish)
            {
                e.Cancel = true;
            }
        }
        private void tb5_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = !(char.IsLetter(e.KeyChar) || e.KeyChar == (char)Keys.Back);
        }
        private void sub_Enter(object sender, EventArgs e)
        {
            Cursor.Position = new Point(this.Width / 2 - 80, Cursor.Position.Y);
        }
        //Submission
        private void enter_Click(object sender, EventArgs e)
        {
            if (textBox5.TextLength != 0)
            {
                Console.WriteLine(textBox5.TextLength);
                finish = true;
                tabControl1.SelectedIndex = 1;
                finish = false;
                username = textBox5.Text;
                restart();
            }
        }
        private void submit_Click(object sender, EventArgs e)
        {
            //Caclulate points
            correct_letters = Compare_Text(textDisplay, textResponse);
            points += 10 * correct_letters;
            correct_digits = Compare_Sub(subDisplay.Substring(20, 10), subResponse);
            points += 10 * correct_digits;

            //Show Score
            finish = true;
            tabControl1.SelectedTab = Scores;
            finish = false;
            label8.Text = correct_letters.ToString();
            label9.Text = correct_digits.ToString();

            label10.Text = points.ToString();
            label11.Text = score.ToString();
            //    break;
            //case 2:
            label12.Text = prev_score.ToString();
            total_score = prev_score + points + score;
            label13.Text = total_score.ToString();

        }
        //Automatic
        private void timer_Click(object sender, EventArgs e)
        {
            if (tabControl1.SelectedTab == Experiment)
            {
                if (score > 1)
                {
                    score = score - 2;
                    pointsLabel.Text = score + "";
                }
                else
                {
                    timer1.Stop();
                    MessageBox.Show("You didn't finish in time. Try Again !!", "Sorry");
                    timer1.Start();
                    if (trial_ind > -1)
                    {
                        trial_ind--;
                    }
                    //Random rnd = new Random();
                    //Sequence_Start(rnd);
                    restart();
                }
            }
            if (tabControl1.SelectedTab == Scores)
            {
                score_ind++;
                switch (score_ind)
                {
                    case 3:
                        /*label8.Text = correct_letters.ToString();
                        label9.Text = correct_digits.ToString();

                        label10.Text = points.ToString();
                        label11.Text = score.ToString();
                    //    break;
                    //case 2:
                        label12.Text = prev_score.ToString();
                        total_score = prev_score + points + score;
                        label13.Text = total_score.ToString();*/
                        //break;
                    //case 2:
                        //Random rnd = new Random();

                        //Write to excel sheet
                        string[] JoinedData = JoinData(subDisplay.Substring(20, 10), subResponse, correct_digits.ToString(),
                            textDisplay, textResponse, correct_letters.ToString(), points.ToString(),
                            score.ToString(), prev_score.ToString(), total_score.ToString(), sub_time, text_time, version);

                        InsertText(@"R1.xlsx", username, Number2String(trial_ind, true), JoinedData);
                        prev_score = total_score;
                        //Sequence_Start(rnd);
                        restart();
                        break;
                }
            }
        }
        private void tb5_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter && textBox5.TextLength !=0 )
            {
                //Console.Write(textBox5.TextLength+" ");
                //Console.Write(textBox5.Text);
                finish = true;
                tabControl1.SelectedIndex = 1;
                finish = false;
                username = textBox5.Text;
                restart();
            }
        }
    }
}
